package ru.dbotthepony.kstarbound.client.gl.program

import ru.dbotthepony.kstarbound.client.gl.GLStateTracker
import ru.dbotthepony.kstarbound.client.gl.shader.GLShader

private fun loadShaders(
	vertex: Collection<String>,
	fragment: Collection<String>
): Array<GLShader> {
	val result = arrayOfNulls<GLShader>(vertex.size + fragment.size)
	var i = 0

	for (name in vertex) {
		result[i++] = GLShader.internalVertex("shaders/$name.vsh")
	}

	for (name in fragment) {
		result[i++] = GLShader.internalFragment("shaders/$name.fsh")
	}

	return result as Array<GLShader>
}

open class GLInternalProgram(
	state: GLStateTracker,
	vertex: Collection<String>,
	fragment: Collection<String>
) : GLShaderProgram(state, *loadShaders(vertex, fragment)) {
	constructor(state: GLStateTracker, name: String) : this(state, listOf(name), listOf(name))
}
